;;;=============================================================================
;;;          "BRICKS.LSP" : BRICKS HATCH PATTERN CREATOR
;;;;;; * Bricks patterns are created on the fly, with length, height & joint size of
;;;   your choice.;;; * Two different heights can be used.
;;; * Overlapping bricks is optional.
;;; * Afterwards, BHATCH command is invoked with the new pattern name as default.
;;;;;; "Your imagination is the limit" - Raymond Rizkallah - Nov./2007
;;;==============================================================================
(defun C:BRK ()
  (prompt " **, Ÿ, ױ ġ **")
  (if (null (numberp l1))
    (setq l1 15.0)
  )
  (if (null (numberp h1))
    (setq h1 5.0)
  )
  (if (null (numberp h2))
    (setq h2 3)
  )
  (if (null (numberp j1))
    (setq j1 0.5)
  )
  (setq	dir-name (findfile "acad.pat")
	str-len	 (strlen dir-name)
  )
  (setq dir-name (substr dir-name 1 (- str-len 8)))
  (while
    (findfile
      (strcat dir-name
	      (setq b-name (getstring "\n    ̸: "))
	      ".pat"
      )
    )
     (alert "\n ̸ ̹ մϴ... ٽ Էֽʽÿ. ")
  )
  (setq nl1 (getdist (strcat "\n   <" (rtos l1) ">: ")))
  (setq nh1 (getdist (strcat "\n ù°    <" (rtos h1) ">: ")))
  (setq nh2 (getdist (strcat "\n ι°   <" (rtos h2) ">: ")))
  (setq nj1 (getdist (strcat "\n  κ ũ   <" (rtos j1) ">: ")))
  (initget "Yes No")
  (setq opt (getkword "\n   Դϱ? [Yes/No] <Y>: "))
  (if (null opt)
    (setq opt "Yes")
  )
  (if nl1
    (setq l1 nl1)
  )
  (if nh1
    (setq h1 nh1)
  )
  (if nh2
    (setq h2 nh2)
  )
  (if nj1
    (setq j1 nj1)
  )
  (setq l1x (/ l1 2.0))
  (setq j1x (/ j1 2.0))
					;------------------- Overlapped -----------------------------------
  (setq	p-lst1 (list
 ;___ brick hatch pattern name (overlapped bricks)
		 (strcat "*"
			 b-name
			 ", "
			 "L="
			 (rtos l1 2 2)
			 " H1="
			 (rtos h1 2 2)
			 " H2="
			 (rtos h2 2 2)
			 " Jt="
			 (rtos j1 2 2)
			 " - Ovr."
		 ) ;___
 ;___ brick-1: line 1
		 (strcat "0,   "
			 "0,0,   "
			 "0,"
			 (rtos (+ h1 j1 h2 j1) 2 3)
			 ",   "
			 (rtos l1 2 3)
			 ",-"
			 (rtos j1 2 3)
		 )
 ;___ brick-1: line 2
		 (strcat "0,   "
			 "0,"
			 (rtos h1 2 3)
			 ",   "
			 "0,"
			 (rtos (+ h1 j1 h2 j1) 2 3)
			 ",   "
			 (rtos l1 2 3)
			 ",-"
			 (rtos j1 2 3)
		 )
 ;___ brick-1: line 3
		 (strcat "90,   "
			 "0,0,   "
			 "0,"
			 (rtos (+ l1 j1) 2 3)
			 ",   "
			 (rtos h1 2 3)
			 ",-"
			 (rtos (+ j1 h2 j1) 2 3)
		 )
 ;___ brick-1: line 4
		 (strcat "90,   "
			 (rtos l1 2 3)
			 ",0,   "
			 "0,"
			 (rtos (+ l1 j1) 2 3)
			 ",   "
			 (rtos h1 2 3)
			 ",-"
			 (rtos (+ j1 h2 j1) 2 3)
		 )
 ;___    ;___ brick-2: line 1
		 (strcat "0,   "
			 (rtos (+ l1x j1x) 2 3)
			 ","
			 (rtos (+ h1 j1) 2 3)
			 ",   "
			 "0,"
			 (rtos (+ h2 j1 h1 j1) 2 3)
			 ",   "
			 (rtos l1 2 3)
			 ",-"
			 (rtos j1 2 3)
		 )
 ;___ brick-2: line 2
		 (strcat "0,   "
			 (rtos (+ l1x j1x) 2 3)
			 ","
			 (rtos (+ h1 j1 h2) 2 3)
			 ",   "
			 "0,"
			 (rtos (+ h1 j1 h2 j1) 2 3)
			 ",   "
			 (rtos l1 2 3)
			 ",-"
			 (rtos j1 2 3)
		 )
 ;___ brick-2: line 3
		 (strcat "90,   "
			 (rtos (+ l1x j1x) 2 3)
			 ","
			 (rtos (+ h1 j1) 2 3)
			 ",   "
			 "0,"
			 (rtos (+ l1 j1) 2 3)
			 ",   "
			 (rtos h2 2 3)
			 ",-"
			 (rtos (+ j1 h1 j1) 2 3)
		 )
 ;___ brick-2: line 4
		 (strcat "90,   "
			 (rtos (+ l1x j1x l1) 2 3)
			 ","
			 (rtos (+ h1 j1) 2 3)
			 ",   "
			 "0,"
			 (rtos (+ l1 j1) 2 3)
			 ",   "
			 (rtos h2 2 3)
			 ",-"
			 (rtos (+ j1 h1 j1) 2 3)
		 )
	       )
  )
					;end list/setq
					;------------------- Not Overlapped -------------------------------
  (setq	p-lst2 (list ;___ brick hatch pattern name (not overlapped)
		 (strcat "*"
			 b-name
			 ", "
			 "L="
			 (rtos l1 2 2)
			 " H1="
			 (rtos h1 2 2)
			 " H2="
			 (rtos h2 2 2)
			 " Jt="
			 (rtos j1 2 2)
			 " - Str."
		 )
 ;___    ;___ brick-1: line 1
		 (strcat "0,   "
			 "0,0,   "
			 "0,"
			 (rtos (+ h1 j1 h2 j1) 2 3)
			 ",   "
			 (rtos l1 2 3)
			 ",-"
			 (rtos j1 2 3)
		 )
 ;___ brick-1: line 2
		 (strcat "0,   "
			 "0,"
			 (rtos h1 2 3)
			 ",   "
			 "0,"
			 (rtos (+ h1 j1 h2 j1) 2 3)
			 ",   "
			 (rtos l1 2 3)
			 ",-"
			 (rtos j1 2 3)
		 )
 ;___ brick-1: line 3
		 (strcat "90,   "
			 "0,0,   "
			 "0,"
			 (rtos (+ l1 j1) 2 3)
			 ",   "
			 (rtos h1 2 3)
			 ",-"
			 (rtos (+ j1 h2 j1) 2 3)
		 )
 ;___ brick-1: line 4
		 (strcat "90,   "
			 (rtos l1 2 3)
			 ",0,   "
			 "0,"
			 (rtos (+ l1 j1) 2 3)
			 ",   "
			 (rtos h1 2 3)
			 ",-"
			 (rtos (+ j1 h2 j1) 2 3)
		 )
 ;___    ;___ brick-2: line 1
		 (strcat "0,   "
			 "0,"
			 (rtos (+ h1 j1) 2 3)
			 ",   "
			 "0,"
			 (rtos (+ h2 j1 h1 j1) 2 3)
			 ",   "
			 (rtos l1 2 3)
			 ",-"
			 (rtos j1 2 3)
		 )
 ;___ brick-2: line 2
		 (strcat "0,   "
			 "0,"
			 (rtos (+ h1 j1 h2) 2 3)
			 ",   "
			 "0,"
			 (rtos (+ h1 j1 h2 j1) 2 3)
			 ",   "
			 (rtos l1 2 3)
			 ",-"
			 (rtos j1 2 3)
		 )
 ;___ brick-2: line 3
		 (strcat "90,   "
			 "0,"
			 (rtos (+ h1 j1) 2 3)
			 ",   "
			 "0,"
			 (rtos (+ l1 j1) 2 3)
			 ",   "
			 (rtos h2 2 3)
			 ",-"
			 (rtos (+ j1 h1 j1) 2 3)
		 )
 ;___ brick-2: line 4
		 (strcat "90,   "
			 (rtos l1 2 3)
			 ","
			 (rtos (+ h1 j1) 2 3)
			 ",   "
			 "0,"
			 (rtos (+ l1 j1) 2 3)
			 ",   "
			 (rtos h2 2 3)
			 ",-"
			 (rtos (+ j1 h1 j1) 2 3)
		 )
	       )
  )
					;end list/setq
					;------------------------------------------------------------------
  (if (= opt "Yes")
    (setq p-lst p-lst1)
    (setq p-lst p-lst2)
  )
  (setq n1 1)
  (foreach n p-lst
    (if	(> (strlen n) 80)
      (progn
	(alert
	  (strcat
	    "\n Line ["
	    (itoa n1)
	    "] Pattern Definition Contains more than 80 Characters."
	    "\n                  <OPERATION DISCARED...>"
	  )
	)
	(EXIT)
      )
    )
    (setq n1 (1+ n1))
  )
  (setq f (open (strcat dir-name b-name ".pat") "w"))
  (foreach n p-lst (write-line n f))
  (close f)
  (alert
    (strcat
      "\n["
      b-name
      ".pat]  Ʒ    ε߽ϴ:"
      "\n  ["
      dir-name
      "]"
      "\n  "
     )
  )
  (setvar "hpname" b-name)
  (setvar "hpscale" 1)
  (princ)
;;  (command "bhatch")
)
;end C:BRICK;;;====================================================================
(PROMPT
  "\n, Ÿ ġ   ɾ : BRK "
)
(PRINC)